#include <pth.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/un.h>
#include <unistd.h>
#include "unix_serve.h"

struct _thread_data
{
  client_handler_t *handler;
  int sock;
  void *data;
};

static void *
_handler_thread (void *_arg)
{
  struct _thread_data *td = (struct _thread_data *) _arg;
  client_handler_t *handler = td->handler;
  int sock = td->sock;
  void *data = td->data;
  free (td);
  handler (sock, data);
  close (sock);
  return NULL;
}

int
unix_serve (int sock, client_handler_t * handler, void *data)
{
  while (1)
    {
      struct sockaddr_un sun;
      socklen_t length = sizeof (sun);
      int new_sock = pth_accept (sock, (struct sockaddr *) &sun, &length);

      if (new_sock >= 0)
	{
	  struct _thread_data *td =
	    (struct _thread_data *) malloc (sizeof (struct _thread_data));

	  if (td == NULL)
	    {
	      close (new_sock);
	      return -1;
	    }

	  td->handler = handler;
	  td->sock = new_sock;
	  td->data = data;
	  pth_spawn (PTH_ATTR_DEFAULT, _handler_thread, (void *) td);
	}
      else
	return -1;
    }
}
