#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/un.h>
#include <unistd.h>
#include "usound_internal.h"

int
_usound_unix_connect (const char *path)
{
  struct sockaddr_un sun;
  int sock;

  /* Fill in the sockaddr_un structure. */
  memset ((void *) &sun, 0, sizeof (sun));
  sun.sun_family = AF_UNIX;
  strcpy (sun.sun_path, path);

  /* Create the socket. */
  if ((sock = socket (AF_UNIX, SOCK_STREAM, 0)) < 0)
    return -1;

  /* Finally, open the connection. */
  if (connect (sock, (struct sockaddr *) &sun, sizeof (sun)) < 0)
    {
      close (sock);
      return -1;
    }

  return sock;
}
