#ifndef _USOUND_H_
#define _USOUND_H_

#ifdef __cplusplus
extern "C"
{
#endif

  typedef struct _usound_output *usound_output_t;

  int usound_is_available (void);
  usound_output_t usound_open_output (int sample_bytes, int channels,
				      int rate);
  int usound_play (usound_output_t stream);
  int usound_stop (usound_output_t stream);
  int usound_is_playing (usound_output_t stream);
  int usound_write (usound_output_t stream, const void *buf, int bytes);
  int usound_sync (usound_output_t stream);
  int usound_reset_output (usound_output_t stream);
  int usound_get_output_volume (usound_output_t stream);
  int usound_set_output_volume (usound_output_t stream, int volume);
  long long usound_get_bytes_played (usound_output_t stream);
  int usound_set_output_nonblock (usound_output_t stream, int nonblock);
  int usound_is_writable (usound_output_t stream);
  int usound_get_output_buffer_size (usound_output_t stream);
  int usound_get_output_space (usound_output_t stream);
  void usound_close_output (usound_output_t stream);
  int usound_open_input (int rate);

#ifdef __cplusplus
}
#endif

#endif /* not _USOUND_H_ */
