#include <stdlib.h>
#include <unistd.h>
#include "usound_internal.h"

usound_output_t
usound_open_output (int sample_bytes, int channels, int rate)
{
  int control_fd = -1, data_fd = -1, index = -1,
    tmp = sample_bytes | (channels << 16);
  unsigned char cmd = 1;
  usound_output_t stream = NULL;
  control_fd = _usound_unix_connect ("/dev/usound/ctl");

  if (control_fd == -1)
    return NULL;

  if (write (control_fd, &cmd, sizeof (cmd)) <= 0 ||
      read (control_fd, &index, sizeof (index)) <= 0 || index < 0 ||
      (data_fd = _usound_unix_connect ("/dev/usound/out")) == -1)
    {
      close (control_fd);
      return NULL;
    }

  if (write (data_fd, &index, sizeof (index)) <= 0 ||
      write (data_fd, &tmp, sizeof (tmp)) <= 0 ||
      write (data_fd, &rate, sizeof (rate)) <= 0 ||
      (stream = (usound_output_t) malloc (sizeof (struct _usound_output)))
      == NULL)
    {
      close (data_fd);
      close (control_fd);
      return NULL;
    }

  stream->control_fd = control_fd;
  stream->data_fd = data_fd;
  return stream;
}
