#include <fcntl.h>
#include <unistd.h>
#include "usound_internal.h"

int
usound_set_output_nonblock (usound_output_t stream, int nonblock)
{
  int flags = fcntl (stream->data_fd, F_GETFL);

  if (flags < 0)
    return flags;

  if (nonblock)
    flags |= O_NONBLOCK;
  else
    flags &= ~O_NONBLOCK;

  return fcntl (stream->data_fd, F_SETFL, flags);
}
